enum TicketListType { ALL, MY }

extension TICKET_LIST_TYPE on TicketListType {
  String get type {
    switch (this) {
      case TicketListType.MY:
        return "my";
      case TicketListType.ALL:
        return "all";
    }
  }
}

enum TicketListStatus {
  ONHOLD,
  UNASSIGNED,
  ASSIGNED,
  RESOLVED,
  CLOSED,
  REOPEN,
  ASSIGNED_REOPEN
}

extension TICKET_LIST_STATUS on TicketListStatus {
  String get type {
    switch (this) {
      case TicketListStatus.ASSIGNED:
        return "Assigned";
      case TicketListStatus.REOPEN:
        return "Reopen";
      case TicketListStatus.ONHOLD:
        return "On Hold";
      case TicketListStatus.UNASSIGNED:
        return "Unassigned";
      case TicketListStatus.ASSIGNED_REOPEN:
        return "Assigned,Reopen";
      case TicketListStatus.RESOLVED:
        return "Resolved";
      case TicketListStatus.CLOSED:
        return "Closed";
      default:
        return "";
    }
  }
}
