import 'package:flutter/material.dart';


import '../utils/colors.dart';
import '../utils/hexColors.dart';
import '../utils/text_styling.dart';

class CircularAvatar extends StatelessWidget {
  final String name;
  final bool showFullText;
  final double height;
  final double width;
  final Color? color;

  CircularAvatar(
      {required this.name,
      this.showFullText = false,
      this.height = 40,
      this.width = 40,
      this.color});

  @override
  Widget build(BuildContext context) {
    var styleElements = TextStyleElements(context);
    return new Container(
      width: height,
      height: width,
      decoration: new BoxDecoration(
        color: color ?? HexColor(AppColors.appMainColor),
        shape: BoxShape.circle,
      ),
      child: Center(
        child: Text(
          showFullText ? name : name[0].toUpperCase(),
          style: styleElements.headline6ThemeScalable(context).copyWith(
              fontWeight: FontWeight.bold,
              color: HexColor(AppColors.appColorWhite)),
        ),
      ),
    );
  }
}
