import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:lead_management/presentation/utils/app_buttons.dart';
import 'package:lead_management/presentation/utils/colors.dart';
import 'package:lead_management/presentation/utils/custom_app_bar.dart';
import 'package:lead_management/presentation/utils/customcard.dart';
import 'package:lead_management/presentation/utils/hexColors.dart';
import 'package:lead_management/presentation/utils/text_styling.dart';

import '../../enums/ticket_list_type.dart';
import '../common_widgets/app_find_card.dart';
import '../common_widgets/customgridDelegate.dart';
import '../utils/app_user_list_tile.dart';
import '../utils/localization.dart';
import '../utils/searchBox.dart';
import 'filter_issues.dart';
import 'helpdesk_chat_screen.dart';

class LeadRefresncesPage extends StatefulWidget {
  const LeadRefresncesPage({Key? key}) : super(key: key);

  @override
  LeadRefresncesPageState createState() => LeadRefresncesPageState();
}

class LeadRefresncesPageState extends State<LeadRefresncesPage> {
  String? date;

  int startTime = DateTime(1900).millisecondsSinceEpoch;
  int endTime = DateTime.now().millisecondsSinceEpoch;
  TextStyleElements? styleElements;

  @override
  void initState() {
    super.initState();
    WidgetsBinding.instance!.addPostFrameCallback((timeStamp) {});
  }

  @override
  Widget build(BuildContext context) {
    styleElements = TextStyleElements(context);
    return SafeArea(
      child: Scaffold(
        appBar: appAppBar().getCustomAppBar(
          context,
          appBarTitle: "Lead references",
          actions: [IconButton(onPressed: (){

            Navigator.push(context,
                MaterialPageRoute(builder: (BuildContext context) {
                  return HelpDeskChatScreen(key: null,);
                }));


          }, icon: Icon(Icons.add)),IconButton(onPressed: (){


            _showBottomSheet();


          }, icon: Icon(Icons.segment))],
          onBackButtonPress: () {
            Navigator.pop(context);
          },
        ),
        body: ListView(
          children: [

            SearchBox(onvalueChanged: (String value) {  },hintText: "Search",),
            GestureDetector(
            behavior: HitTestBehavior.translucent,
            onTap: () {},
            child: appUserListTile(
              onPressed: () {
                Navigator.push(context,
                    MaterialPageRoute(builder: (BuildContext context) {
                      return HelpDeskChatScreen(key: null,);
                    }));
              },
              showDivider: true,
              padding: EdgeInsets.only(left: 16, right: 12, top: 8, bottom: 4),
              decoration: BoxDecoration(
                // color: widget.status == TicketListStatus.CLOSED.type
                //     ? HexColor(AppColors.appColorWhite)
                //     : HexColor(item.priorityColor ??
                //         item.tierColor ??
                //         AppColors.appColorWhite),
                  color: HexColor(AppColors.appColorWhite)),
              showAvatar: true,
              imageUrl: "",
              isOnline: false,
              title:"Savil Kumar",
              subtitle1: "#12304904",
              subtitle3: "Employee | open",

              // trailingWidget: Visibility(
              //   visible: widget.showOptions,
              //   child: IconButton(
              //     icon: Icon(Icons.more_vert),
              //     onPressed: () {
              //       _showManageticketSheet(item);
              //     },
              //   ),
              // ),
              showCount:true,
              count: 23,
              superScriptText:"23:00" ,
              // Utility().getDateFormat(
              //     "${prefs.getString(Strings.dateFormat)!} ${prefs.getString(Strings.timeFormat)!}",
              //     DateTime.fromMillisecondsSinceEpoch(
              //         item.last_comment_created_at ?? 0)),
            )),
            GestureDetector(
                behavior: HitTestBehavior.translucent,
                onTap: () {},
                child: appUserListTile(
                  onPressed: () {

                  },
                  showDivider: true,
                  padding: EdgeInsets.only(left: 16, right: 12, top: 8, bottom: 4),
                  decoration: BoxDecoration(
                    // color: widget.status == TicketListStatus.CLOSED.type
                    //     ? HexColor(AppColors.appColorWhite)
                    //     : HexColor(item.priorityColor ??
                    //         item.tierColor ??
                    //         AppColors.appColorWhite),
                      color: HexColor(AppColors.appColorWhite)),
                  showAvatar: true,
                  imageUrl: "",
                  isOnline: false,
                  title:"Savil Kumar",
                  subtitle1: "#12304904",
                  subtitle3: "Employee | open",

                  // trailingWidget: Visibility(
                  //   visible: widget.showOptions,
                  //   child: IconButton(
                  //     icon: Icon(Icons.more_vert),
                  //     onPressed: () {
                  //       _showManageticketSheet(item);
                  //     },
                  //   ),
                  // ),
                  showCount:true,
                  count: 23,
                  superScriptText:"23:00" ,
                  // Utility().getDateFormat(
                  //     "${prefs.getString(Strings.dateFormat)!} ${prefs.getString(Strings.timeFormat)!}",
                  //     DateTime.fromMillisecondsSinceEpoch(
                  //         item.last_comment_created_at ?? 0)),
                )),
          ],
        ),
      ),
    );
  }

  void openTicketListPage(BuildContext context,
      {String? status,
        String? listType,
        bool isNewTicket = false,
        bool showOptions = true,
        bool showRating = false}) {
    /*  Navigator.push(context, MaterialPageRoute(builder: (BuildContext context) {
      return HelpDeskTicketListPage(
          isNewTicket: isNewTicket,
          status: status,
          listType: listType,
          showOptions: showOptions,
          showRating: showRating,
          callback: () {
            refresh();
          });
    }));*/
  }

  void refresh() {
    // fetchData(startTime, endTime);
  }


  void _showBottomSheet() {
    showModalBottomSheet(
      context: context,
      shape: const RoundedRectangleBorder(
          borderRadius: BorderRadius.only(
              topLeft: Radius.circular(12), topRight: Radius.circular(12))),
      builder: (BuildContext context) {
        return FilterTicketSheet(
          listType:  TicketListType.MY.type.toLowerCase(),
          status: TicketListStatus.ASSIGNED.type,
          callback: (value, listType) {

            refresh();
          },
        );
      },
    );
  }



}

class LeadRefresncesPageDisplayWidget extends StatelessWidget {
  final String? title;
  final String? subtitle;
  final bool isIconShow;
  final Function? onPressed;
  final Widget? icon;

  LeadRefresncesPageDisplayWidget(
      {this.title,
        this.subtitle,
        this.isIconShow = false,
        this.onPressed,
        this.icon});

  @override
  Widget build(BuildContext context) {
    var styleElements = TextStyleElements(context);
    return appListCard(
      onTap: onPressed,
      padding: EdgeInsets.only(left: 8, bottom: 6, right: 8, top: 8),
      child: Row(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Visibility(visible: isIconShow, child: icon ?? Container()),
          Expanded(
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                Text(
                  title ?? "",
                  style: isIconShow
                      ? styleElements.subtitle1ThemeScalable(context).copyWith(
                    fontWeight: FontWeight.bold,
                  )
                      : styleElements.bodyText2ThemeScalable(context),
                  maxLines: 1,
                  overflow: TextOverflow.ellipsis,
                ),
                isIconShow ? Container() : Spacer(),
                Row(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  mainAxisAlignment: MainAxisAlignment.start,
                  children: [
                    if (!isIconShow) Spacer(),
                    if (isIconShow)
                      Flexible(
                        child: Text(
                          subtitle ?? "",
                          style: styleElements.bodyText2ThemeScalable(context),
                        ),
                      ),
                    if (!isIconShow)
                      Text(
                        subtitle ?? "",
                        style: styleElements
                            .subtitle1ThemeScalable(context)
                            .copyWith(
                          fontWeight: FontWeight.bold,
                        ),
                      ),
                  ],
                )
              ],
            ),
          ),
        ],
      ),
    );
  }
}
